天天看点

Leetcode337. 打家劫舍 IIILeetcode337. 打家劫舍 III

Leetcode337. 打家劫舍 III

题目:

在上次打劫完一条街道之后和一圈房屋后,小偷又发现了一个新的可行窃的地区。这个地区只有一个入口,我们称之为“根”。 除了“根”之外,每栋房子有且只有一个“父“房子与之相连。一番侦察之后,聪明的小偷意识到“这个地方的所有房屋的排列类似于一棵二叉树”。 如果两个直接相连的房子在同一天晚上被打劫,房屋将自动报警。

计算在不触动警报的情况下,小偷一晚能够盗取的最高金额。

示例 1:

输入: [3,2,3,null,3,null,1]

     3
    / \
   2   3
    \   \ 
     3   1

输出: 7 
解释: 小偷一晚能够盗取的最高金额 = 3 + 3 + 1 = 7.
示例 2:

输入: [3,4,5,1,3,null,1]

     3
    / \
   4   5
  / \   \ 
 1   3   1

输出: 9
解释: 小偷一晚能够盗取的最高金额 = 4 + 5 = 9.
           

题解:

方案一:暴力递归+最优子结构

  • 4 个孙子偷的钱 + 爷爷的钱 VS 两个儿子偷的钱,哪个组合钱多,就当做当前节点能偷的最大钱数。 这就是动态规划里面的最优子结构。

方案二:将每一次的计算结果存储到hashMap中

方案三:

每个节点可选择偷或者不偷两种状态,根据题目意思,相连节点不能一起偷

当前节点选择偷时,那么两个孩子节点就不能选择偷了;

当前节点选择不偷时,两个孩子节点只需要拿最多的钱出来就行(两个孩子节点偷不偷没关系);

我们使用一个大小为 2 的数组来表示 int[] res = new int[2] 0 代表不偷,1 代表偷

任何一个节点能偷到的最大钱的状态可以定义为:

  1. 当前节点选择不偷:当前节点能偷到的最大钱数 = 左孩子能偷到的钱 + 右孩子能偷到的钱
  2. 当前节点选择偷:当前节点能偷到的最大钱数 = 左孩子选择自己不偷时能得到的钱 + 右孩子选择不偷时能得到的钱 + 当前节点的钱数

    java代码:

    方案一:

/**
     * 暴力递归+最优子结构
     *
     * @param root
     * @return
     */
    public static int rob(TreeNode root) {
        if (root == null) return 0;

        int money = root.value;
        if (root.left != null) {
            money += (rob(root.left.left) + rob(root.left.right));
        }

        if (root.right != null) {
            money += (rob(root.right.left) + rob(root.right.right));
        }
        return Math.max(money, rob(root.left) + rob(root.right));
    }
           

方案二:

/**
     * @param root
     * @return
     */
    public static int rob2(TreeNode root) {
        HashMap<TreeNode, Integer> map = new HashMap<>();
        return helper(root, map);
    }

    /**
     * 将每一次的计算结果存储到hashMap中
     *
     * @param root
     * @param map
     * @return
     */
    private static int helper(TreeNode root, HashMap<TreeNode, Integer> map) {

        if (root == null) return 0;
        if (map.containsKey(root)) return map.get(root);

        int money = root.value;

        if (root.left != null) {
            money += helper(root.left.left, map) + helper(root.left.right, map);
        }
        if (root.right != null) {
            money += helper(root.right.left, map) + helper(root.right.right, map);
        }
        int result = Math.max(money, helper(root.left, map) + helper(root.right, map));

        map.put(root, result);
        return result;
    }
           

方案三:

/**
     *  result[0]代表当前节点不偷,result[1]代表当前节点偷
     * 当前节点选择不偷:当前节点能偷到的最大钱数 = 左孩子能偷到的钱 + 右孩子能偷到的钱
     * 当前节点选择偷:当前节点能偷到的最大钱数 = 左孩子选择自己不偷时能得到的钱 + 右孩子选择自己不偷时能得到的钱 + 当前节点的钱数
     *
     * @param root
     * @return
     */
    public static int rob3(TreeNode root) {
        int[] result = robInternal(root);
        return Math.max(result[0], result[1]);

    }

    private static int[] robInternal(TreeNode root) {
        if (root == null) return new int[2];
        int[] result = new int[2];

        int[] left = robInternal(root.left);
        int[] right = robInternal(root.right);

        result[0] = Math.max(left[0], left[1]) + Math.max(right[0], right[1]);
        result[1] = left[0] + right[0] + root.value;

        return result;
    }